/* gitg-animated-paned.c generated by valac 0.32.1, the Vala compiler
 * generated from gitg-animated-paned.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2014 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gio/gio.h>


#define GITG_TYPE_SLIDE_DIRECTION (gitg_slide_direction_get_type ())

#define GITG_TYPE_SLIDE_PANED_CHILD (gitg_slide_paned_child_get_type ())

#define GITG_TYPE_ANIMATED_PANED (gitg_animated_paned_get_type ())
#define GITG_ANIMATED_PANED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GITG_TYPE_ANIMATED_PANED, GitgAnimatedPaned))
#define GITG_ANIMATED_PANED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GITG_TYPE_ANIMATED_PANED, GitgAnimatedPanedClass))
#define GITG_IS_ANIMATED_PANED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GITG_TYPE_ANIMATED_PANED))
#define GITG_IS_ANIMATED_PANED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GITG_TYPE_ANIMATED_PANED))
#define GITG_ANIMATED_PANED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GITG_TYPE_ANIMATED_PANED, GitgAnimatedPanedClass))

typedef struct _GitgAnimatedPaned GitgAnimatedPaned;
typedef struct _GitgAnimatedPanedClass GitgAnimatedPanedClass;
typedef struct _GitgAnimatedPanedPrivate GitgAnimatedPanedPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GitgAnimatedPanedSlideAsyncData GitgAnimatedPanedSlideAsyncData;

typedef enum  {
	GITG_SLIDE_DIRECTION_IN,
	GITG_SLIDE_DIRECTION_OUT
} GitgSlideDirection;

typedef enum  {
	GITG_SLIDE_PANED_CHILD_FIRST,
	GITG_SLIDE_PANED_CHILD_SECOND
} GitgSlidePanedChild;

struct _GitgAnimatedPaned {
	GtkPaned parent_instance;
	GitgAnimatedPanedPrivate * priv;
};

struct _GitgAnimatedPanedClass {
	GtkPanedClass parent_class;
};

struct _GitgAnimatedPanedPrivate {
	gint d_target_pos;
	gint d_original_pos;
	gint d_start_pos;
	gint64 d_slide_start;
	gint64 d_slide_duration;
	guint d_tick_id;
	GSourceFunc d_async_callback;
	gpointer d_async_callback_target;
	GDestroyNotify d_async_callback_target_destroy_notify;
	GitgSlideDirection d_direction;
	GitgSlidePanedChild d_child;
	guint _transition_duration;
};

struct _GitgAnimatedPanedSlideAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GitgAnimatedPaned* self;
	GitgSlidePanedChild child;
	GitgSlideDirection direction;
	gboolean should_animate;
	GtkSettings* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	guint _tmp3_;
	GitgSlideDirection _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_;
	guint _tmp7_;
	gboolean _tmp8_;
	guint _tmp9_;
	gboolean _tmp10_;
	guint _tmp11_;
	GdkFrameClock* _tmp12_;
	gint64 _tmp13_;
	gint _tmp14_;
	GitgSlideDirection _tmp15_;
	GitgSlidePanedChild _tmp16_;
	gdouble factor;
	gint w;
	GtkOrientation _tmp17_;
	GtkOrientation _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GitgSlideDirection _tmp21_;
	GitgSlidePanedChild _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gdouble div;
	GitgSlidePanedChild _tmp29_;
	gint _tmp30_;
	GtkWidget* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	GtkWidget* _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
	gdouble _tmp37_;
	gboolean _tmp38_;
	gdouble _tmp39_;
	guint _tmp40_;
};


static gpointer gitg_animated_paned_parent_class = NULL;

GType gitg_slide_direction_get_type (void) G_GNUC_CONST;
GType gitg_slide_paned_child_get_type (void) G_GNUC_CONST;
GType gitg_animated_paned_get_type (void) G_GNUC_CONST;
#define GITG_ANIMATED_PANED_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GITG_TYPE_ANIMATED_PANED, GitgAnimatedPanedPrivate))
enum  {
	GITG_ANIMATED_PANED_DUMMY_PROPERTY,
	GITG_ANIMATED_PANED_TRANSITION_DURATION,
	GITG_ANIMATED_PANED_IS_ANIMATING
};
static gboolean gitg_animated_paned_update_position (GitgAnimatedPaned* self, gdouble factor);
static gboolean gitg_animated_paned_on_animate_step (GitgAnimatedPaned* self, GtkWidget* widget, GdkFrameClock* clock);
static void gitg_animated_paned_real_dispose (GObject* base);
void gitg_animated_paned_slide (GitgAnimatedPaned* self, GitgSlidePanedChild child, GitgSlideDirection direction);
static void gitg_animated_paned_slide_async (GitgAnimatedPaned* self, GitgSlidePanedChild child, GitgSlideDirection direction, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void gitg_animated_paned_slide_finish (GitgAnimatedPaned* self, GAsyncResult* _res_);
static void __lambda79_ (GitgAnimatedPaned* self, GObject* obj, GAsyncResult* res);
static void ___lambda79__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void gitg_animated_paned_slide_async_data_free (gpointer _data);
static gboolean gitg_animated_paned_slide_async_co (GitgAnimatedPanedSlideAsyncData* _data_);
static gboolean _gitg_animated_paned_on_animate_step_gtk_tick_callback (GtkWidget* widget, GdkFrameClock* frame_clock, gpointer self);
static gboolean _gitg_animated_paned_slide_async_co_gsource_func (gpointer self);
guint gitg_animated_paned_get_transition_duration (GitgAnimatedPaned* self);
static gboolean ___lambda78_ (GitgAnimatedPaned* self);
static gboolean ____lambda78__gsource_func (gpointer self);
GitgAnimatedPaned* gitg_animated_paned_new (void);
GitgAnimatedPaned* gitg_animated_paned_construct (GType object_type);
void gitg_animated_paned_set_transition_duration (GitgAnimatedPaned* self, guint value);
gboolean gitg_animated_paned_get_is_animating (GitgAnimatedPaned* self);
static void gitg_animated_paned_finalize (GObject* obj);
static void _vala_gitg_animated_paned_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gitg_animated_paned_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType gitg_slide_direction_get_type (void) {
	static volatile gsize gitg_slide_direction_type_id__volatile = 0;
	if (g_once_init_enter (&gitg_slide_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{GITG_SLIDE_DIRECTION_IN, "GITG_SLIDE_DIRECTION_IN", "in"}, {GITG_SLIDE_DIRECTION_OUT, "GITG_SLIDE_DIRECTION_OUT", "out"}, {0, NULL, NULL}};
		GType gitg_slide_direction_type_id;
		gitg_slide_direction_type_id = g_enum_register_static ("GitgSlideDirection", values);
		g_once_init_leave (&gitg_slide_direction_type_id__volatile, gitg_slide_direction_type_id);
	}
	return gitg_slide_direction_type_id__volatile;
}


GType gitg_slide_paned_child_get_type (void) {
	static volatile gsize gitg_slide_paned_child_type_id__volatile = 0;
	if (g_once_init_enter (&gitg_slide_paned_child_type_id__volatile)) {
		static const GEnumValue values[] = {{GITG_SLIDE_PANED_CHILD_FIRST, "GITG_SLIDE_PANED_CHILD_FIRST", "first"}, {GITG_SLIDE_PANED_CHILD_SECOND, "GITG_SLIDE_PANED_CHILD_SECOND", "second"}, {0, NULL, NULL}};
		GType gitg_slide_paned_child_type_id;
		gitg_slide_paned_child_type_id = g_enum_register_static ("GitgSlidePanedChild", values);
		g_once_init_leave (&gitg_slide_paned_child_type_id__volatile, gitg_slide_paned_child_type_id);
	}
	return gitg_slide_paned_child_type_id__volatile;
}


static gboolean gitg_animated_paned_update_position (GitgAnimatedPaned* self, gdouble factor) {
	gboolean result = FALSE;
	gint pos = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
#line 54 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp0_ = self->priv->d_target_pos;
#line 56 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp1_ = self->priv->d_start_pos;
#line 56 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp2_ = factor;
#line 56 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp3_ = round ((_tmp0_ - _tmp1_) * _tmp2_);
#line 56 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp4_ = self->priv->d_start_pos;
#line 56 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	pos = ((gint) _tmp3_) + _tmp4_;
#line 58 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp5_ = pos;
#line 58 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	gtk_paned_set_position ((GtkPaned*) self, _tmp5_);
#line 59 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 61 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp6_ = pos;
#line 61 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp7_ = self->priv->d_target_pos;
#line 61 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	if (_tmp6_ == _tmp7_) {
#line 236 "gitg-animated-paned.c"
		GSourceFunc _tmp8_ = NULL;
		void* _tmp8__target = NULL;
		GitgSlideDirection _tmp10_ = 0;
#line 63 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		self->priv->d_tick_id = (guint) 0;
#line 65 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_tmp8_ = self->priv->d_async_callback;
#line 65 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_tmp8__target = self->priv->d_async_callback_target;
#line 65 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		if (_tmp8_ != NULL) {
#line 248 "gitg-animated-paned.c"
			GSourceFunc _tmp9_ = NULL;
			void* _tmp9__target = NULL;
#line 67 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_tmp9_ = self->priv->d_async_callback;
#line 67 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_tmp9__target = self->priv->d_async_callback_target;
#line 67 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_tmp9_ (_tmp9__target);
#line 257 "gitg-animated-paned.c"
		}
#line 70 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_tmp10_ = self->priv->d_direction;
#line 70 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		if (_tmp10_ == GITG_SLIDE_DIRECTION_OUT) {
#line 263 "gitg-animated-paned.c"
			GitgSlidePanedChild _tmp11_ = 0;
#line 72 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_tmp11_ = self->priv->d_child;
#line 72 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			if (_tmp11_ == GITG_SLIDE_PANED_CHILD_FIRST) {
#line 269 "gitg-animated-paned.c"
				GtkWidget* _tmp12_ = NULL;
#line 74 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
				_tmp12_ = gtk_paned_get_child1 ((GtkPaned*) self);
#line 74 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
				gtk_widget_hide (_tmp12_);
#line 275 "gitg-animated-paned.c"
			} else {
				GtkWidget* _tmp13_ = NULL;
#line 78 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
				_tmp13_ = gtk_paned_get_child2 ((GtkPaned*) self);
#line 78 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
				gtk_widget_hide (_tmp13_);
#line 282 "gitg-animated-paned.c"
			}
		}
#line 82 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		result = FALSE;
#line 82 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		return result;
#line 289 "gitg-animated-paned.c"
	}
#line 85 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	result = TRUE;
#line 85 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	return result;
#line 295 "gitg-animated-paned.c"
}


static gboolean gitg_animated_paned_on_animate_step (GitgAnimatedPaned* self, GtkWidget* widget, GdkFrameClock* clock) {
	gboolean result = FALSE;
	gint64 elapsed = 0LL;
	GdkFrameClock* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	gint64 _tmp2_ = 0LL;
	gdouble factor = 0.0;
	gint64 _tmp3_ = 0LL;
	gint64 _tmp4_ = 0LL;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gboolean _tmp7_ = FALSE;
#line 88 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 88 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_return_val_if_fail (clock != NULL, FALSE);
#line 90 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp0_ = clock;
#line 90 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp1_ = gdk_frame_clock_get_frame_time (_tmp0_);
#line 90 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp2_ = self->priv->d_slide_start;
#line 90 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	elapsed = _tmp1_ - _tmp2_;
#line 91 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp3_ = elapsed;
#line 91 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp4_ = self->priv->d_slide_duration;
#line 91 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	factor = ((gdouble) _tmp3_) / ((gdouble) _tmp4_);
#line 93 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp5_ = factor;
#line 93 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp6_ = fmin (_tmp5_, (gdouble) 1);
#line 93 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp7_ = gitg_animated_paned_update_position (self, _tmp6_);
#line 93 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	if (!_tmp7_) {
#line 95 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		self->priv->d_tick_id = (guint) 0;
#line 96 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		g_object_notify ((GObject*) self, "is-animating");
#line 97 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		result = FALSE;
#line 97 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		return result;
#line 347 "gitg-animated-paned.c"
	}
#line 100 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	result = TRUE;
#line 100 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	return result;
#line 353 "gitg-animated-paned.c"
}


static void gitg_animated_paned_real_dispose (GObject* base) {
	GitgAnimatedPaned * self;
	guint _tmp0_ = 0U;
#line 103 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	self = (GitgAnimatedPaned*) base;
#line 105 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp0_ = self->priv->d_tick_id;
#line 105 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 366 "gitg-animated-paned.c"
		guint _tmp1_ = 0U;
#line 107 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_tmp1_ = self->priv->d_tick_id;
#line 107 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		gtk_widget_remove_tick_callback ((GtkWidget*) self, _tmp1_);
#line 108 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		self->priv->d_tick_id = (guint) 0;
#line 374 "gitg-animated-paned.c"
	}
#line 111 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	G_OBJECT_CLASS (gitg_animated_paned_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_paned_get_type (), GtkPaned));
#line 378 "gitg-animated-paned.c"
}


static void __lambda79_ (GitgAnimatedPaned* self, GObject* obj, GAsyncResult* res) {
	GAsyncResult* _tmp0_ = NULL;
#line 122 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_return_if_fail (res != NULL);
#line 123 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp0_ = res;
#line 123 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	gitg_animated_paned_slide_finish (self, _tmp0_);
#line 390 "gitg-animated-paned.c"
}


static void ___lambda79__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 122 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	__lambda79_ ((GitgAnimatedPaned*) self, source_object, res);
#line 122 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_object_unref (self);
#line 399 "gitg-animated-paned.c"
}


void gitg_animated_paned_slide (GitgAnimatedPaned* self, GitgSlidePanedChild child, GitgSlideDirection direction) {
	GitgSlidePanedChild _tmp0_ = 0;
	GitgSlideDirection _tmp1_ = 0;
#line 119 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_return_if_fail (self != NULL);
#line 122 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp0_ = child;
#line 122 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp1_ = direction;
#line 122 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	gitg_animated_paned_slide_async (self, _tmp0_, _tmp1_, ___lambda79__gasync_ready_callback, g_object_ref (self));
#line 414 "gitg-animated-paned.c"
}


static void gitg_animated_paned_slide_async_data_free (gpointer _data) {
	GitgAnimatedPanedSlideAsyncData* _data_;
	_data_ = _data;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_g_object_unref0 (_data_->self);
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_slice_free (GitgAnimatedPanedSlideAsyncData, _data_);
#line 425 "gitg-animated-paned.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	return self ? g_object_ref (self) : NULL;
#line 432 "gitg-animated-paned.c"
}


static void gitg_animated_paned_slide_async (GitgAnimatedPaned* self, GitgSlidePanedChild child, GitgSlideDirection direction, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GitgAnimatedPanedSlideAsyncData* _data_;
	GitgAnimatedPaned* _tmp0_ = NULL;
	GitgSlidePanedChild _tmp1_ = 0;
	GitgSlideDirection _tmp2_ = 0;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_ = g_slice_new0 (GitgAnimatedPanedSlideAsyncData);
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, gitg_animated_paned_slide_async);
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, gitg_animated_paned_slide_async_data_free);
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->self = _tmp0_;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp1_ = child;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->child = _tmp1_;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp2_ = direction;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->direction = _tmp2_;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	gitg_animated_paned_slide_async_co (_data_);
#line 461 "gitg-animated-paned.c"
}


static void gitg_animated_paned_slide_finish (GitgAnimatedPaned* self, GAsyncResult* _res_) {
	GitgAnimatedPanedSlideAsyncData* _data_;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 469 "gitg-animated-paned.c"
}


static gboolean _gitg_animated_paned_on_animate_step_gtk_tick_callback (GtkWidget* widget, GdkFrameClock* frame_clock, gpointer self) {
	gboolean result;
	result = gitg_animated_paned_on_animate_step ((GitgAnimatedPaned*) self, widget, frame_clock);
#line 141 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	return result;
#line 478 "gitg-animated-paned.c"
}


static gboolean _gitg_animated_paned_slide_async_co_gsource_func (gpointer self) {
	gboolean result;
	result = gitg_animated_paned_slide_async_co (self);
#line 203 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	return result;
#line 487 "gitg-animated-paned.c"
}


static gboolean ___lambda78_ (GitgAnimatedPaned* self) {
	gboolean result = FALSE;
#line 212 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	gitg_animated_paned_update_position (self, (gdouble) 1);
#line 213 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	result = FALSE;
#line 213 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	return result;
#line 499 "gitg-animated-paned.c"
}


static gboolean ____lambda78__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda78_ ((GitgAnimatedPaned*) self);
#line 211 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	return result;
#line 508 "gitg-animated-paned.c"
}


static gboolean gitg_animated_paned_slide_async_co (GitgAnimatedPanedSlideAsyncData* _data_) {
#line 127 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	switch (_data_->_state_) {
#line 127 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		case 0:
#line 517 "gitg-animated-paned.c"
		goto _state_0;
#line 127 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		case 1:
#line 521 "gitg-animated-paned.c"
		goto _state_1;
		default:
#line 127 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		g_assert_not_reached ();
#line 526 "gitg-animated-paned.c"
	}
	_state_0:
#line 130 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp0_ = NULL;
#line 130 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp0_ = gtk_widget_get_settings ((GtkWidget*) _data_->self);
#line 130 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp1_ = FALSE;
#line 130 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_object_get (_data_->_tmp0_, "gtk-enable-animations", &_data_->_tmp1_, NULL);
#line 130 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp2_ = FALSE;
#line 130 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 130 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->should_animate = _data_->_tmp2_;
#line 132 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp3_ = 0U;
#line 132 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp3_ = _data_->self->priv->d_tick_id;
#line 132 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	if (_data_->_tmp3_ == ((guint) 0)) {
#line 134 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp4_ = 0;
#line 134 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp4_ = _data_->direction;
#line 134 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		if (_data_->_tmp4_ == GITG_SLIDE_DIRECTION_OUT) {
#line 136 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp5_ = 0;
#line 136 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp5_ = gtk_paned_get_position ((GtkPaned*) _data_->self);
#line 136 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->self->priv->d_original_pos = _data_->_tmp5_;
#line 561 "gitg-animated-paned.c"
		}
#line 139 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp6_ = FALSE;
#line 139 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp6_ = _data_->should_animate;
#line 139 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		if (_data_->_tmp6_) {
#line 141 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp7_ = 0U;
#line 141 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp7_ = gtk_widget_add_tick_callback ((GtkWidget*) _data_->self, _gitg_animated_paned_on_animate_step_gtk_tick_callback, g_object_ref (_data_->self), g_object_unref);
#line 141 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->self->priv->d_tick_id = _data_->_tmp7_;
#line 142 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			g_object_notify ((GObject*) _data_->self, "is-animating");
#line 577 "gitg-animated-paned.c"
		}
	} else {
#line 145 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp9_ = 0U;
#line 145 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp9_ = _data_->self->priv->d_tick_id;
#line 145 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		if (_data_->_tmp9_ != ((guint) 0)) {
#line 145 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp10_ = FALSE;
#line 145 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp10_ = _data_->should_animate;
#line 145 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp8_ = !_data_->_tmp10_;
#line 592 "gitg-animated-paned.c"
		} else {
#line 145 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp8_ = FALSE;
#line 596 "gitg-animated-paned.c"
		}
#line 145 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		if (_data_->_tmp8_) {
#line 147 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp11_ = 0U;
#line 147 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp11_ = _data_->self->priv->d_tick_id;
#line 147 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			gtk_widget_remove_tick_callback ((GtkWidget*) _data_->self, _data_->_tmp11_);
#line 148 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->self->priv->d_tick_id = (guint) 0;
#line 149 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			g_object_notify ((GObject*) _data_->self, "is-animating");
#line 610 "gitg-animated-paned.c"
		}
	}
#line 152 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp12_ = NULL;
#line 152 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp12_ = gtk_widget_get_frame_clock ((GtkWidget*) _data_->self);
#line 152 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp13_ = 0LL;
#line 152 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp13_ = gdk_frame_clock_get_frame_time (_data_->_tmp12_);
#line 152 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_slide_start = _data_->_tmp13_;
#line 153 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp14_ = 0;
#line 153 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp14_ = gtk_paned_get_position ((GtkPaned*) _data_->self);
#line 153 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_start_pos = _data_->_tmp14_;
#line 154 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp15_ = 0;
#line 154 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp15_ = _data_->direction;
#line 154 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_direction = _data_->_tmp15_;
#line 155 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp16_ = 0;
#line 155 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp16_ = _data_->child;
#line 155 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_child = _data_->_tmp16_;
#line 160 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp17_ = 0;
#line 160 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp17_ = gtk_orientable_get_orientation ((GtkOrientable*) _data_->self);
#line 160 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp18_ = 0;
#line 160 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 160 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	if (_data_->_tmp18_ == GTK_ORIENTATION_VERTICAL) {
#line 162 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp19_ = 0;
#line 162 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp19_ = gtk_widget_get_allocated_height ((GtkWidget*) _data_->self);
#line 162 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->w = _data_->_tmp19_;
#line 657 "gitg-animated-paned.c"
	} else {
#line 166 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp20_ = 0;
#line 166 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp20_ = gtk_widget_get_allocated_width ((GtkWidget*) _data_->self);
#line 166 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->w = _data_->_tmp20_;
#line 665 "gitg-animated-paned.c"
	}
#line 169 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp21_ = 0;
#line 169 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp21_ = _data_->direction;
#line 169 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	if (_data_->_tmp21_ == GITG_SLIDE_DIRECTION_OUT) {
#line 171 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp22_ = 0;
#line 171 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp22_ = _data_->child;
#line 171 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		if (_data_->_tmp22_ == GITG_SLIDE_PANED_CHILD_FIRST) {
#line 173 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->self->priv->d_target_pos = 0;
#line 681 "gitg-animated-paned.c"
		} else {
#line 177 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp23_ = 0;
#line 177 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp23_ = _data_->w;
#line 177 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->self->priv->d_target_pos = _data_->_tmp23_;
#line 689 "gitg-animated-paned.c"
		}
#line 180 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp24_ = 0;
#line 180 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp24_ = _data_->self->priv->d_target_pos;
#line 180 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp25_ = 0;
#line 180 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp25_ = _data_->self->priv->d_start_pos;
#line 180 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp26_ = 0;
#line 180 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp26_ = _data_->self->priv->d_target_pos;
#line 180 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp27_ = 0;
#line 180 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp27_ = _data_->self->priv->d_original_pos;
#line 180 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->factor = (((gdouble) _data_->_tmp24_) - ((gdouble) _data_->_tmp25_)) / (((gdouble) _data_->_tmp26_) - ((gdouble) _data_->_tmp27_));
#line 709 "gitg-animated-paned.c"
	} else {
#line 185 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp28_ = 0;
#line 185 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp28_ = _data_->self->priv->d_original_pos;
#line 185 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->self->priv->d_target_pos = _data_->_tmp28_;
#line 189 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp29_ = 0;
#line 189 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp29_ = _data_->child;
#line 189 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		if (_data_->_tmp29_ == GITG_SLIDE_PANED_CHILD_FIRST) {
#line 191 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp30_ = 0;
#line 191 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp30_ = _data_->self->priv->d_original_pos;
#line 191 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->div = (gdouble) _data_->_tmp30_;
#line 192 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp31_ = NULL;
#line 192 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp31_ = gtk_paned_get_child1 ((GtkPaned*) _data_->self);
#line 192 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			gtk_widget_show (_data_->_tmp31_);
#line 735 "gitg-animated-paned.c"
		} else {
#line 196 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp32_ = 0;
#line 196 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp32_ = _data_->self->priv->d_original_pos;
#line 196 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp33_ = 0;
#line 196 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp33_ = _data_->w;
#line 196 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->div = (gdouble) (_data_->_tmp32_ - _data_->_tmp33_);
#line 197 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp34_ = NULL;
#line 197 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			_data_->_tmp34_ = gtk_paned_get_child2 ((GtkPaned*) _data_->self);
#line 197 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
			gtk_widget_show (_data_->_tmp34_);
#line 753 "gitg-animated-paned.c"
		}
#line 200 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp35_ = 0;
#line 200 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp35_ = _data_->self->priv->d_target_pos;
#line 200 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp36_ = 0;
#line 200 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp36_ = _data_->self->priv->d_start_pos;
#line 200 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp37_ = 0.0;
#line 200 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp37_ = _data_->div;
#line 200 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->factor = (((gdouble) _data_->_tmp35_) - ((gdouble) _data_->_tmp36_)) / _data_->_tmp37_;
#line 769 "gitg-animated-paned.c"
	}
#line 203 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	(_data_->self->priv->d_async_callback_target_destroy_notify == NULL) ? NULL : (_data_->self->priv->d_async_callback_target_destroy_notify (_data_->self->priv->d_async_callback_target), NULL);
#line 203 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_async_callback = NULL;
#line 203 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_async_callback_target = NULL;
#line 203 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_async_callback_target_destroy_notify = NULL;
#line 203 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_async_callback = _gitg_animated_paned_slide_async_co_gsource_func;
#line 203 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_async_callback_target = _data_;
#line 203 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_async_callback_target_destroy_notify = NULL;
#line 205 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp38_ = FALSE;
#line 205 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_tmp38_ = _data_->should_animate;
#line 205 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	if (_data_->_tmp38_) {
#line 207 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp39_ = 0.0;
#line 207 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp39_ = _data_->factor;
#line 207 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp40_ = 0U;
#line 207 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->_tmp40_ = _data_->self->priv->_transition_duration;
#line 207 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		_data_->self->priv->d_slide_duration = ((gint64) (_data_->_tmp39_ * _data_->_tmp40_)) * 1000;
#line 801 "gitg-animated-paned.c"
	} else {
#line 211 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda78__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 805 "gitg-animated-paned.c"
	}
#line 217 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_data_->_state_ = 1;
#line 217 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	return FALSE;
#line 811 "gitg-animated-paned.c"
	_state_1:
	;
#line 127 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	if (_data_->_state_ == 0) {
#line 127 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 818 "gitg-animated-paned.c"
	} else {
#line 127 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 822 "gitg-animated-paned.c"
	}
#line 127 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_object_unref (_data_->_async_result);
#line 127 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	return FALSE;
#line 828 "gitg-animated-paned.c"
}


GitgAnimatedPaned* gitg_animated_paned_construct (GType object_type) {
	GitgAnimatedPaned * self = NULL;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	self = (GitgAnimatedPaned*) g_object_new (object_type, NULL);
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	return self;
#line 838 "gitg-animated-paned.c"
}


GitgAnimatedPaned* gitg_animated_paned_new (void) {
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	return gitg_animated_paned_construct (GITG_TYPE_ANIMATED_PANED);
#line 845 "gitg-animated-paned.c"
}


guint gitg_animated_paned_get_transition_duration (GitgAnimatedPaned* self) {
	guint result;
	guint _tmp0_ = 0U;
#line 49 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 49 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp0_ = self->priv->_transition_duration;
#line 49 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	result = _tmp0_;
#line 49 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	return result;
#line 860 "gitg-animated-paned.c"
}


void gitg_animated_paned_set_transition_duration (GitgAnimatedPaned* self, guint value) {
	guint _tmp0_ = 0U;
#line 50 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_return_if_fail (self != NULL);
#line 50 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp0_ = value;
#line 50 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	self->priv->_transition_duration = _tmp0_;
#line 50 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_object_notify ((GObject *) self, "transition-duration");
#line 874 "gitg-animated-paned.c"
}


gboolean gitg_animated_paned_get_is_animating (GitgAnimatedPaned* self) {
	gboolean result;
	guint _tmp0_ = 0U;
#line 116 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 116 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	_tmp0_ = self->priv->d_tick_id;
#line 116 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	result = _tmp0_ != ((guint) 0);
#line 116 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	return result;
#line 889 "gitg-animated-paned.c"
}


static void gitg_animated_paned_class_init (GitgAnimatedPanedClass * klass) {
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	gitg_animated_paned_parent_class = g_type_class_peek_parent (klass);
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_type_class_add_private (klass, sizeof (GitgAnimatedPanedPrivate));
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	((GObjectClass *) klass)->dispose = gitg_animated_paned_real_dispose;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_animated_paned_get_property;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gitg_animated_paned_set_property;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	G_OBJECT_CLASS (klass)->finalize = gitg_animated_paned_finalize;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_ANIMATED_PANED_TRANSITION_DURATION, g_param_spec_uint ("transition-duration", "transition-duration", "transition-duration", 0, G_MAXUINT, (guint) 250, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_ANIMATED_PANED_IS_ANIMATING, g_param_spec_boolean ("is-animating", "is-animating", "is-animating", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 910 "gitg-animated-paned.c"
}


static void gitg_animated_paned_instance_init (GitgAnimatedPaned * self) {
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	self->priv = GITG_ANIMATED_PANED_GET_PRIVATE (self);
#line 47 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	self->priv->_transition_duration = (guint) 250;
#line 919 "gitg-animated-paned.c"
}


static void gitg_animated_paned_finalize (GObject* obj) {
	GitgAnimatedPaned * self;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_ANIMATED_PANED, GitgAnimatedPaned);
#line 43 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	(self->priv->d_async_callback_target_destroy_notify == NULL) ? NULL : (self->priv->d_async_callback_target_destroy_notify (self->priv->d_async_callback_target), NULL);
#line 43 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	self->priv->d_async_callback = NULL;
#line 43 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	self->priv->d_async_callback_target = NULL;
#line 43 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	self->priv->d_async_callback_target_destroy_notify = NULL;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	G_OBJECT_CLASS (gitg_animated_paned_parent_class)->finalize (obj);
#line 937 "gitg-animated-paned.c"
}


GType gitg_animated_paned_get_type (void) {
	static volatile gsize gitg_animated_paned_type_id__volatile = 0;
	if (g_once_init_enter (&gitg_animated_paned_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GitgAnimatedPanedClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_animated_paned_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgAnimatedPaned), 0, (GInstanceInitFunc) gitg_animated_paned_instance_init, NULL };
		GType gitg_animated_paned_type_id;
		gitg_animated_paned_type_id = g_type_register_static (gtk_paned_get_type (), "GitgAnimatedPaned", &g_define_type_info, 0);
		g_once_init_leave (&gitg_animated_paned_type_id__volatile, gitg_animated_paned_type_id);
	}
	return gitg_animated_paned_type_id__volatile;
}


static void _vala_gitg_animated_paned_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GitgAnimatedPaned * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_ANIMATED_PANED, GitgAnimatedPaned);
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	switch (property_id) {
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		case GITG_ANIMATED_PANED_TRANSITION_DURATION:
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		g_value_set_uint (value, gitg_animated_paned_get_transition_duration (self));
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		break;
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		case GITG_ANIMATED_PANED_IS_ANIMATING:
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		g_value_set_boolean (value, gitg_animated_paned_get_is_animating (self));
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		break;
#line 970 "gitg-animated-paned.c"
		default:
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		break;
#line 976 "gitg-animated-paned.c"
	}
}


static void _vala_gitg_animated_paned_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GitgAnimatedPaned * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_ANIMATED_PANED, GitgAnimatedPaned);
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
	switch (property_id) {
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		case GITG_ANIMATED_PANED_TRANSITION_DURATION:
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		gitg_animated_paned_set_transition_duration (self, g_value_get_uint (value));
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		break;
#line 992 "gitg-animated-paned.c"
		default:
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "/home/jesse/dev/gitg/gitg/gitg-animated-paned.vala"
		break;
#line 998 "gitg-animated-paned.c"
	}
}



